<template>
    <div class="calendar">
      <el-button @click="() => getPosts(null, null, true)">
        Latest Posts
      </el-button>
      <el-collapse v-model="activeName" accordion>
        <el-collapse-item
          @click="() => setYear(year)"
          v-for="(year, index) in years"
          :key="index"
          :title="year + ''"
          :name="index"
        >
          <ul>
            <li v-for="(month, index) in months" :key="index" @click="() => getPosts(year, month)">
              {{ numberToMonth(month) }}
            </li>
          </ul>
        </el-collapse-item>
      </el-collapse>
    </div>
  </template>
  
  <script setup lang="ts">
  import { ref, onMounted } from 'vue';
  import axios, { AxiosResponse } from 'axios';
  import useEmitter from '../composables/useEmitter';
  
  const MONTHS_IN_YEAR = 12;
  
  const emitter = useEmitter();
  
  const activeName = ref('1');
  const years = ref<number[]>([]);
  const months = ref<number[]>([]);
  const yearSelected = ref<number | null>(null);
  const year = ref<number | null>(null);
  const month = ref<number | null>(null);
  const earliestMonth = ref<number | null>(null);
  
  onMounted(() => {
    
    axios
      .get(`${import.meta.env.VITE_HOST}:${import.meta.env.VITE_PORT}/api/v1/post/min`)
      .then((response: AxiosResponse<Date>) => {
        const start: Date = new Date(response.data);
        const yearStart: number = start.getFullYear();
        const monthStart: number = start.getMonth() + 1;
        earliestMonth.value = monthStart;
        const now: Date = new Date();
        year.value = now.getFullYear();
        month.value = now.getMonth() + 1;
  
        for (let i = year.value; i >= yearStart; i--) {
          years.value.push(i);
        }
      })
      .catch((err) => {
        console.error(err);
      });
  });
  
  function setYear(newYear) {
    
    if (yearSelected.value === newYear) return;
    yearSelected.value = newYear;
    months.value = [];
  
    if (newYear === years.value.at(-1) && newYear !==years.value[0]) {
      for (let i = earliestMonth.value, max = 12; i <= max; i++) {
        months.value.push(i);
      }
      return;
    }
    
    if (newYear === years.value[0]) {
      
      for (let i = 1; i <= month.value; i++) {
        months.value.push(i);
      }
      return;
    }
  
    for (let i = 1; i <= MONTHS_IN_YEAR; i++) {
      months.value.push(i);
    }
  }
  
  function getPosts(year, month, all = false) {
    emitter.emit('getPosts', { year, month, all });
  }
  
  function numberToMonth(number) {
    switch (number) {
      case 1:
        return 'January';
      case 2:
        return 'February';
      case 3:
        return 'March';
      case 4:
        return 'April';
      case 5:
        return 'May';
      case 6:
        return 'June';
      case 7:
        return 'July';
      case 8:
        return 'August';
      case 9:
        return 'September';
      case 10:
        return 'October';
      case 11:
        return 'November';
      case 12:
        return 'December';
    }
  }
  </script>
  
  <style scoped lang="scss">
  .calendar {
    width: 20%;
    margin-left: 10px;
  
    ul {
      list-style-type: none;
      cursor: pointer;
    }
  }
  </style>
  